//#include "SEGGER_RTT.h"
#include "Pub_prt.h"
#define printk

#ifndef false
#define false 0
#endif


#ifndef true
#define  true 1
#endif 


#ifndef NULL
#define NULL 0
#endif 


static unsigned char write_cyc_fifo(void *arg, unsigned char data);
static unsigned char read_cyc_fifo(void *arg, unsigned char *data);
static unsigned char read_cyc_fifo_all(void *arg, unsigned char *data, unsigned int *len);
static unsigned int get_cyc_fifo_len(void *arg);


static unsigned char write_cyc_fifo(void *arg, unsigned char data)
{
	dsCycFifo *handle = (dsCycFifo *)arg;

	if (NULL == handle) return false;

	handle->fifo_buf[handle->fifo_wptr] = data;

	handle->fifo_wptr = (handle->fifo_wptr + 1) % MAX_CYC_FIFO;

	return true;
}

static unsigned char write_cyc_fifoEx(void *arg, unsigned char *data, unsigned short len)
{
	dsCycFifo *handle = (dsCycFifo *)arg;

	if (NULL == handle) return false;
	if (len > MAX_CYC_FIFO) return false;

	for (unsigned int i = 0; i < len; i++)
	{
		handle->fifo_buf[handle->fifo_wptr] = data[i];
		if (++handle->fifo_wptr >= MAX_CYC_FIFO) handle->fifo_wptr = 0;
	}

	return true;
}

static unsigned char read_cyc_fifo(void *arg, unsigned char *data)
{
	dsCycFifo *handle = (dsCycFifo *)arg;

	if (NULL == handle || data == NULL) return false;

	*data = handle->fifo_buf[handle->fifo_rptr];

	handle->fifo_rptr = (handle->fifo_rptr + 1) % MAX_CYC_FIFO;

	return true;
}

//ȡζе
static unsigned char read_cyc_fifo_all(void *arg, unsigned char *data, unsigned int *len)
{
	dsCycFifo *handle = (dsCycFifo *)arg;

	if (NULL == handle || data == NULL) return false;

	unsigned int length = get_cyc_fifo_len(handle);

	for (unsigned int i = 0; i < length; i++)
	{
		read_cyc_fifo(handle, data + i);
	}

	*len = length;

	return true;
}

//ȡζݵĳ
static unsigned int get_cyc_fifo_len(void *arg)
{
	dsCycFifo *handle = (dsCycFifo *)arg;

	if (NULL == handle) return false;

	if (handle->fifo_rptr < handle->fifo_wptr)
	{
		handle->fifo_len = handle->fifo_wptr - handle->fifo_rptr;
	}
	else if (handle->fifo_rptr > handle->fifo_wptr)
	{
		handle->fifo_len = MAX_CYC_FIFO - handle->fifo_rptr + handle->fifo_wptr;
	}
	else
		handle->fifo_len = 0;

	return handle->fifo_len;
}


static unsigned char get_xor(unsigned char *buf, unsigned int len)
{
	if (0 == len) return 0;

	unsigned char check = buf[0];

	for (unsigned int i = 1; i < len; i++)
	{
		check = check ^ buf[i];
	}

	return check;
}


static unsigned char add_u8(unsigned char *buf, unsigned int *index, unsigned char value)
{
	unsigned int idx = *index;

	buf[idx++] = value;

	*index = idx;

	return true;
}

/*
static unsigned char add_u16(unsigned char *buf, unsigned int *index, unsigned short value)
{
unsigned int idx = *index;

buf[idx++] = value >> 8;
buf[idx++] = value & 0xff;

*index = idx;

return true;
}
*/

static unsigned char add_fp32(unsigned char *buf, unsigned int *index, float value)
{
	unsigned int idx = *index;

	unsigned char *data = (unsigned char *)&value;



	buf[idx++] = data[3];
	buf[idx++] = data[2];
	buf[idx++] = data[1];
	buf[idx++] = data[0];

	*index = idx;

	return true;
}



////ڽ
//static void ComIstTest()
//{
//	unsigned char t[] = { 0xa5, 0x11 ,0x00 ,0x01 ,0x00 ,0xb5 ,0x0d };
//
//	for (int i = 0; i < sizeof(t); i++)
//	{
//		Com_Receive_Isr(&m_comHandle, t[i]);
//	}
//}


//Խյһ֡кϷж: ֡ͷ֡βУ
static unsigned char Com_CheckRecvFrame_Standerd(unsigned char *buf, unsigned int len)
{
	if (len < 4 + 2) return 0;
	if (PUB_PRT_HEAD != buf[0] || PUB_PRT_TAIL != buf[len - 1]) return 0;

	unsigned char check_get = buf[len - 2];
	unsigned char check_cal = get_xor(buf, len - 2);

	if (check_get == check_cal) return 1;
	else return 0;
}



//1ڽջصдζ
static void Com_ReceiveCallBack(void *hd, unsigned char *buf, unsigned int len)
{
	dsPubCommModule *handle = (dsPubCommModule *)hd;
	write_cyc_fifoEx(&handle->recvFifo, buf, len);
}


//3ڱ׼ʽ֡ ״̬
unsigned char Com_Receive_Isr(void * args, unsigned char temp)
{
	dsPubCommModule *handle = (dsPubCommModule *)args;

	unsigned char ret = 0;

	if (0 == handle) return 0;

	if (handle->rxCnt < MAX_FRAME_SIZE)
	{
	}
	else
	{
		handle->rxCnt = 0;
	}
        

	handle->frm_Buf[handle->rxCnt++] = temp;


	switch (handle->state)
	{
	case 0://head
		if (PUB_PRT_HEAD == temp)
		{
			handle->state = 1;
			handle->rxCnt = 1;
			handle->frm_Buf[0] = temp;
		}
		else
			handle->rxCnt = 0;
		break;

	case 1://cmd
		if (PUB_PRT_HEAD == temp)
		{
			handle->state = 1;
			handle->rxCnt = 1;
			handle->frm_Buf[0] = temp;
		}
		else
			handle->state = 2;
		break;

	case 2://fun
		handle->state = 3;
		break;

	case 3://Frm length
		handle->rxLen = temp;
		handle->state = 4;
		break;

	case 4:
		if (handle->rxCnt >= handle->rxLen + 4 + 2)
		{
			if (Com_CheckRecvFrame_Standerd(handle->frm_Buf, handle->rxLen + 6))
			{
				//parse 
				unsigned char *pFrm = &handle->frm_Buf[0];
				unsigned int lenFrm = handle->rxLen + 6;

				//ص    
				if (handle->m_pFunc_Parse != NULL)
					handle->m_pFunc_Parse(pFrm, lenFrm);

				ret = 1;
			}

			handle->rxCnt = 0;
                        handle->rxLen = 0;
			handle->state = 0;
		}
		break;

	default:
		break;
	}
	return ret;
}



//2ڽѭζ
static void Com_ReceiveLoop(void *hd)
{

	dsPubCommModule *handle = (dsPubCommModule *)hd;
	dsCycFifo *fifoHandle = &handle->recvFifo;

	static unsigned int last = 0;

	unsigned char temp = 0;
	unsigned int len = 0;

	len = get_cyc_fifo_len(fifoHandle);


	//
	if (len> 0)// && (len == last))
	{
		//ȡζе, ֽڽ
		for (unsigned int i = 0; i < len; i++)
		{
			if (true == read_cyc_fifo(fifoHandle, &temp))
			{
				Com_Receive_Isr(handle, temp);
			}
		}
	}

	last = len;
}


//ôڱ׼֡Ӧòص
static void Com_SetParseCallBack(void *args, pFun_PrtParse_CallBack fun)
{
	if (NULL == args) return;

	dsPubCommModule *handle = (dsPubCommModule *)args;

	handle->m_pFunc_Parse = fun;
}

void Init_Com(void *args, pFun_PrtParse_CallBack cb)
//void Init_Com(void *args)
{
	dsPubCommModule *handle = (dsPubCommModule *)args;

	if (NULL == handle) return;

	//ѭص
	handle->com_ReceiveLoop = Com_ReceiveLoop;

	//ݻص
	handle->com_ReceiveCallBack = Com_ReceiveCallBack;
        
        handle->Com_SetParseCallBack = Com_SetParseCallBack;

	//Э֡ص
	handle->Com_SetParseCallBack(handle, cb);
//
	//comIstTest();

}

//1 ʼ2 жϵûص 3 ѭloop



//no more




