#include "drv_if.h"
#include <ti/drivers/pin/PINCC26XX.h>
#include <ti/sysbios/knl/Task.h>

PIN_Handle m_ledPinHandle;
PIN_Handle m_cs1PinHandle;
PIN_Handle m_cs2PinHandle;
PIN_Handle m_rstPinHandle;

PIN_Handle m_enPinHandle[4];


unsigned int m_enPort[4] = { MUX_S0, MUX_S1, MUX_S2, MUX_S3};


static void Init_Led()
{
     PIN_setOutputEnable(m_ledPinHandle, LED_RUN, 1);
    
    LED_RUN_OFF;
}



static void Init_CS()
{
	PIN_setOutputEnable(m_cs1PinHandle, MCP_SPI0_CS, 1);

}

static void Init_Rst()
{
	PIN_setOutputEnable(m_rstPinHandle, MCP_SPI0_RST, 1);
}


static void Init_MUX()
{

	for (unsigned char i = 0; i < 4; i++)
	{
		PIN_setOutputEnable(m_enPinHandle[i], m_enPort[i], 1);
		PIN_setOutputValue(m_enPinHandle[i], m_enPort[i], 0);
	}
}


//LD_EN  ͵ƽʹ
void switchMux(unsigned char code)
{
	unsigned char value = 0;

	if (code >= 4) return;

	for (unsigned char i = 0; i < 4; i++)
	{
		value = (code &(1 << i)) ? 1: 0;
		PIN_setOutputValue(m_enPinHandle[i], m_enPort[i], value);
	}
}



void Init_HardWareIO()
{
    Init_Led();
    Init_CS();
    Init_Rst();
    Init_MUX();
}

void led_Off(void)
{

    PIN_setOutputValue(m_ledPinHandle, LED_RUN, 0);
}


void led_Turn(void)
{
    static char flag = 0;
    flag = 1- flag;
    
    PIN_setOutputValue(m_ledPinHandle, LED_RUN, flag);
}

//no more
