#include "drv_mcp3914.h"
#include "drv_if.h"
#include <ti/drivers/pin/PINCC26XX.h>

#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>
#include <ti/sysbios/knl/Semaphore.h>
#include <ti/sysbios/knl/Queue.h>

static unsigned int SendPDValue();

//MCP3914 SPI   0 λ 0, ߼1 λ 1


//Ӳӿڲ
#define CS_LOW()		MCP_CS_EN//HAL_GPIO_WritePin(SPI_CS_GPIO_Port, SPI_CS_Pin, GPIO_PIN_RESET)
#define CS_HIGH()		MCP_CS_DIS//HAL_GPIO_WritePin(SPI_CS_GPIO_Port, SPI_CS_Pin, GPIO_PIN_SET)

#define  osDelay Task_sleep



static void  MCP_Reset();

dsMCPControl m_mcpHandle;


//MCP Ĵʼֵ
const unsigned int mcpRegMap[] =
{
	0x00000000,	// phase0  		  	0x09
	0x00000000,	// phase1  		  	0x0A
	0x00000000,//0x924924,//0x00000000,	// gain 				  0x0B
	0x00A900FF,	// statuscom 			0x0C
	0x00386050,	// config0 	  		0x0D
	0x00000040,	// config1 		  	0x0E
	0x00000000,	// offcal_ch0			0x0F
	0x00000000,	// gaincal_ch0		0x10
	0x00000000,	// offcal_ch1			0x11
	0x00000000,	// gaincal_ch1		0x12
	0x00000000,	// offcal_ch2			0x13
	0x00000000,	// gaincal_ch2		0x14
	0x00000000,	// offcal_ch3			0x15
	0x00000000,	// gaincal_ch3	  0x16
	0x00000000,	// offcal_ch4			0x17
	0x00000000,	// gaincal_ch4	  0x18
	0x00000000,	// offcal_ch5			0x19
	0x00000000,	// gaincal_ch5	  0x1A
	0x00000000,	// offcal_ch6			0x1B
	0x00000000,	// gaincal_ch6	  0x1C
	0x00000000,	// offcal_ch7			0x1D
	0x00000000,	// gaincal_ch7	  0x1E
	0x00A50000,	// lock_crc	  		0x1F
};



//MCPĴ׼ñ־
const unsigned int mcpReadReg[8] =
{
	0x00000001,//ch0
	0x00000002,//ch1
	0x00000004,//ch2
	0x00000008,//ch3
	0x00000010,//ch4
	0x00000020,//ch5
	0x00000040,//ch6
	0x00000080 //ch7
};





static void SPI_Write_If(unsigned char data)
{
	//spi_read_write(adSpiHandle, data);
	spi_read_write(data);
}

static unsigned char SPI_Read_If(unsigned char nl)
{
	unsigned char ret = 0;

	ret = spi_read_write(0xff);

	return ret;
}

//static void osDelay(unsigned int v)
//{
//	volatile unsigned int d = v;
//
//	while (d-- > 0);
//}

static void  MCP_Reset()
{
	MCP_RST_LOW;
	osDelay(10000);
	MCP_RST_HIGH;
}

void SwitchChannel(unsigned char ch)
{

}


static unsigned char MCP3914_SPI_Init(void)
{
	return 0;
}


//ȡMCPַָĴֵ
static unsigned int ReadReg(unsigned char addr)
{
	unsigned int data = 0;
	unsigned char readAddr = 0;

	readAddr = (addr << 1);
	readAddr |= 0x41;

	CS_LOW();

	SPI_Write_If(readAddr);//send read_address

	data = SPI_Read_If(0x00);
	data = (data << 8);
	data += SPI_Read_If(0x00);
	data = (data << 8);
	data += SPI_Read_If(0x00);


	CS_HIGH();

	return(data);

}



//MCPָĴַдֵ
static void WriteReg(unsigned char addr, unsigned int data)
{

	unsigned char writeAddr = 0;
	writeAddr = (addr << 1);
	writeAddr |= 0x40;

	CS_LOW();

	SPI_Write_If(writeAddr);//send write_address
	SPI_Write_If((unsigned char)((data & 0x00FF0000) >> 16));
	SPI_Write_If((unsigned char)((data & 0x0000FF00) >> 8));
	SPI_Write_If((unsigned char)(data & 0x000000FF));

	CS_HIGH();
}

//ʼMCP3914ļĴ
static void Init_MCP3914_Reg(void *args)
{
	dsMCPControl *handle = (dsMCPControl *)args;
	if (handle == MCP_NULL) return;

	handle->WriteReg(MCP_PHASE0, mcpRegMap[0]);
	handle->WriteReg(MCP_PHASE1, mcpRegMap[1]);
	handle->WriteReg(MCP_GAIN, mcpRegMap[2]);
	handle->WriteReg(MCP_STCOM, mcpRegMap[3]);
	handle->WriteReg(MCP_CONFIG0, mcpRegMap[4]);
	handle->WriteReg(MCP_CONFIG1, mcpRegMap[5]);
	handle->WriteReg(MCP_OFSL_CH0, mcpRegMap[6]);
	handle->WriteReg(MCP_GAIN_CH0, mcpRegMap[7]);
	handle->WriteReg(MCP_OFSL_CH1, mcpRegMap[8]);
	handle->WriteReg(MCP_GAIN_CH1, mcpRegMap[9]);
	handle->WriteReg(MCP_OFSL_CH2, mcpRegMap[10]);
	handle->WriteReg(MCP_GAIN_CH2, mcpRegMap[11]);
	handle->WriteReg(MCP_OFSL_CH3, mcpRegMap[12]);
	handle->WriteReg(MCP_GAIN_CH3, mcpRegMap[13]);
	handle->WriteReg(MCP_OFSL_CH4, mcpRegMap[14]);
	handle->WriteReg(MCP_GAIN_CH4, mcpRegMap[15]);
	handle->WriteReg(MCP_OFSL_CH5, mcpRegMap[16]);
	handle->WriteReg(MCP_GAIN_CH5, mcpRegMap[17]);
	handle->WriteReg(MCP_OFSL_CH6, mcpRegMap[18]);
	handle->WriteReg(MCP_GAIN_CH6, mcpRegMap[19]);
	handle->WriteReg(MCP_OFSL_CH7, mcpRegMap[20]);
	handle->WriteReg(MCP_GAIN_CH7, mcpRegMap[21]);
	handle->WriteReg(MCP_LOCK_CRC, mcpRegMap[22]);
}





//ȡڲĴֵ,ȡӵַ9ʼ22Ĵֵ
static void Read_Internal_Registers(void *args)
{
	unsigned char i, address;
	dsMCPControl *handle = (dsMCPControl *)args;

	if (handle == MCP_NULL) return;

	for (i = 0; i < 23; i++)
	{
		address = i + 9;
		handle->interRegs[i] = handle->ReadReg(address);
	}
}




//mcp ȫֳʼ
void  Init_MCP3914(void *args)
{
	dsMCPControl *handle = (dsMCPControl *)args;
	if (handle == MCP_NULL) return;

	//úӳ
	handle->ReadReg = ReadReg;
	handle->WriteReg = WriteReg;
	handle->Read_MCP3914_ADC = Read_MCP3914_ADC;
	handle->SendAdcValue = SendPDValue;
	//handle->SendAdcValue = Send_OneAdc;
	handle->ResetMCP3914 = MCP_Reset;
	handle->SwitchChannel = SwitchChannel;
	handle->Read_Internal_Registers = Read_Internal_Registers;

	handle->send_If = uartTxs;



	handle->ResetMCP3914();
	//ʼSPIӲӿ
	MCP3914_SPI_Init();
	//ʼ3914ڲĴ
	Init_MCP3914_Reg(handle);
	//ڲĴ
	handle->Read_Internal_Registers(handle);
	//д״̬ͨżĴ
	handle->WriteReg(MCP_STCOM, 0x002900FF);
	//дüĴ1
	handle->WriteReg(MCP_CONFIG1, 0x00000000);// |(1u<<6) );


	dsRegMcpConfig0 reg;

	reg.BITS.BOOST = BOOST_MULTI_1_DEFAULT;
	reg.BITS.DITHER = DITHER_MAX_DEFAULT;
	reg.BITS.EN_GAINCAL = EN_OFFCAL_NO_DEFAULT;
	reg.BITS.EN_OFFCAL = EN_OFFCAL_NO_DEFAULT;
	reg.BITS.OSR = OSR_1024;//OSR_1024;// OSR_1024;// OSR_256_DEFAULT;
	reg.BITS.PRE = PRE_DIV_1_DEFAULT;// PRE_DIV_8;//PRE_DIV_1_DEFAULT
	reg.BITS.VREFCAL = VREFCAL_DEFAULT;

	handle->WriteReg(MCP_CONFIG0, reg.BYTES);

	//ڲĴ
	handle->Read_Internal_Registers(handle);
}




unsigned int ReadMCP3914_Ave(void* args, unsigned char ch, unsigned char cnt)
{
	unsigned int ret = 0;
	volatile unsigned int  ready, temp = 0, retry = 0;
	dsMCPControl *handle = (dsMCPControl *)args;

	for (unsigned char i = 0; i < cnt; i++)
	{
		do
		{
			ready = handle->ReadReg(MCP_STCOM);
			ready = ready & mcpReadReg[ch];

			Task_sleep(5 * 100);//100ms

		} while (ready != 0);

		temp = handle->ReadReg(ch) & 0xffffff;
                         
		ret += temp;
	}

	return ret / cnt;
}

int ReadMCP3914_1Channel(void *args, unsigned char i)
{
	dsMCPControl *handle = (dsMCPControl *)args;
	volatile unsigned int  ready;

	if (handle == MCP_NULL)  return MCP_FALSE;
	do
	{
		ready = handle->ReadReg(MCP_STCOM);
		ready = ready & mcpReadReg[i];
	} while (ready != 0);

	handle->adcValue[i] = handle->ReadReg(i);

	return handle->adcValue[i];
}

//ȡ8adcͨԭʼֵ
unsigned int Read_MCP3914_ADC(void *args)
{
	dsMCPControl *handle = (dsMCPControl *)args;
	if (handle == MCP_NULL)  return MCP_FALSE;

	volatile unsigned int  ready;
	volatile unsigned int  adcTemp = 0;
	volatile float f_res = 0;

	unsigned char pdChannel = 0;

        
	for (int j = 0; j < 7; j++)
	{
		//ɨͨл
		handle->SwitchChannel(j+1);
		osDelay(100);

		adcTemp = ReadMCP3914_Ave(handle,j , 1);
		//ȡADCֵ
		handle->adcValue[j] = adcTemp;
	}
        
        

	handle->SendAdcValue();

	return MCP_TRUE;
}




static unsigned char get_check(unsigned char *buf, unsigned char len)
{
	if (len <= 1) return 0;

	unsigned char ret = buf[0];

	for (int i = 1; i < len; i++)
	{
		ret = ret ^ buf[i];
	}

	return ret;
}

static void add_uint24(unsigned char *buf, unsigned int *idx, unsigned int value)
{
	unsigned int index = *idx;

	buf[index++] = (value >> 16) & 0xff;
	buf[index++] = (value >> 8) & 0xff;
	buf[index++] = (value >> 0) & 0xff;
	*idx = index;
}

static void add_fp32(unsigned char *buf, unsigned int *idx, float value)
{
	unsigned int index = *idx;

	unsigned char ibuf[4];

	memcpy(ibuf, &value, 4);

	buf[index++] = ibuf[3];
	buf[index++] = ibuf[2];
	buf[index++] = ibuf[1];
	buf[index++] = ibuf[0];

	*idx = index;
}


static unsigned int SendPDValue()
{
	dsMCPControl *handle = &m_mcpHandle;

	static unsigned char buf[60] = { 0 };
	unsigned int idx = 0;
        
        static unsigned char serial = 0;

	buf[idx++] = 0xa5;
	buf[idx++] = 0x01;
	buf[idx++] = 0x01;
	buf[idx++] = 16 * 3+4+1;

	for (int i = 0; i < 16; i++)
	{
		add_uint24(buf, &idx, handle->adcValue[i]);
	}

	add_fp32(buf, &idx, handle->volBat);
        
        buf[idx++] = serial++;

	unsigned char check = get_check(buf, idx);

	buf[idx++] = check;
	buf[idx++] = 0x0d;
	
	handle->send_If(buf, idx);

	return 0;
}


//no more




