#include <string.h>

#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>
#include <ti/sysbios/knl/Event.h>
#include <ti/sysbios/knl/Queue.h>
#include <ti/display/Display.h>

#include <icall.h>
#include "util.h"
/* This Header file contains all BLE API and icall structure definition */
#include "icall_ble_api.h"

#include "peripheral.h"
#include "heartrateservice.h"
#include "devinfoservice.h"
#include "battservice.h"

#include "board_key.h"
#include "board.h"

#include "heart_rate.h"


#include "drv_if.h"
#include "drv_uart.h"
#include "drv_spi.h"
#include "drv_adc.h"
#include "drv_mcp3914.h"


#define OXY_TASK_PRIORITY                         1
#define OXY_TASK_STACK_SIZE                       1000//644

// Task configuration
Task_Struct OXY_task;
Char OXY_taskStack[OXY_TASK_STACK_SIZE];

static void OXY_taskFxn(UArg a0, UArg a1);


// Entity ID globally used to check for source and/or destination of messages.
static ICall_EntityID selfEntity;
static ICall_SyncHandle syncEvent;


void OXY_createTask(void)
{
  Task_Params taskParams;

  // Configure task
  Task_Params_init(&taskParams);
  taskParams.stack = OXY_taskStack;
  taskParams.stackSize = OXY_TASK_STACK_SIZE;
  taskParams.priority = OXY_TASK_PRIORITY;

  Task_construct(&OXY_task, OXY_taskFxn, &taskParams, NULL);
}

void InitHardware()
{ 
  
    Init_HardWareIO();

    InitSPI();
    InitUart();
    //InitTimer()
    InitAdc();
    
    Init_MCP3914(&m_mcpHandle);
}

void loopTest()
{
      WriteSPI("te", 2);

      ReadAdc();
      
      WriteUart("test ok\r\n", 9);
}

void Loop()
{
    dsMCPControl *mcpHand = &m_mcpHandle;

    unsigned char ofs = 0;

    mcpHand->volBat = ReadAdc();

    for (int j = 0; j < 4; j++)
    {
            switchMux(j);
            
            Task_sleep(2 * 100);//2ms

            for (int i = 0; i < 4; i++)
            {
                    ofs = j * 4 + i;
                    mcpHand->adcValue[ofs] = ReadMCP3914_Ave(mcpHand, i, 1);
            }
    }

    mcpHand->SendAdcValue();


    Task_sleep(10*100);//10ms

    led_Turn();
}



static void OXY_taskFxn(UArg a0, UArg a1)
{
   
   /// ICall_registerApp(&selfEntity, &syncEvent);

    ///Task_sleep(1000*100);
    
   
    
    InitHardware();
 

  
    while(1)
    {

         Loop();     
         
    }
}